#ifndef RUNLIGHTS412613398_H
#define RUNLIGHTS412613398_H

#include "sim_common_definitions.h"

//BLOCK_PREPROC_DEFS_HERE

class SHARED_LIB_TYPE RunLights412613398
{
public:
    RunLights412613398();
    ~RunLights412613398();
    void Initialize(const volatile BLOCK_CONSTRUCTOR_PARAM_STRUCT *arg);
    void PreRun(const volatile GLOBAL_PRERUN_PARAM_STRUCT *arg, _FLOAT32 *in, _FLOAT32 *out);
    void Run(const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FLOAT32 *in, _FLOAT32 *out);
    void RunPlotStep(const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FLOAT32 *in, _FLOAT32 *out);
    void PostRun(const volatile GLOBAL_POSTRUN_PARAM_STRUCT *arg, _FLOAT32 *in, _FLOAT32 *out);
public:
    //block internal parameter variable declaration
    _FLOAT32 base_rate;
    _FLOAT32 input_size;
    _FLOAT32 output_size;
    //block internal initial condition variable declaration
private:
    _BYTE m_prerun_count;
    _UINT64 m_prev_time;
    int m_cur_out_idx;
};

#endif
